/*#######################################################################################
AVR DCF77 Clock

Copyright (C) 2005 Ulrich Radig

#######################################################################################*/

#ifndef _CLOCK_H
 #define _CLOCK_H

extern unsigned char ss;	//Globale Variable fr Sekunden
extern unsigned char mm;	//Globale Variable fr Minuten
extern unsigned char hh;	//Globale Variable fr Stunden
extern unsigned char day;	//Globale Variable fr den Tag
extern unsigned char mon;	//Globale Variable fr den Monat
extern unsigned int year;	//Globale Variable fr den Jahr

extern void Start_Clock (void); //Startet die DCF77 Uhr

//64 Bit fr DCF77 bentigt werden 59 Bits
extern unsigned long long dcf_rx_buffer;
//RX Pointer (Counter)
extern unsigned char rx_bit_counter;

//Interrupt an dem das DCF77 Modul hngt hier INT0
#define DCF77_INT_ENABLE()	enable_external_int (1<<INT0);
#define DCF77_INT			SIG_INTERRUPT0

#define INT0_CONTROL		EICRA
#define INT0_FALLING_EDGE	0x02
#define INT0_RISING_EDGE	0x03

//Structur des dcf_rx_buffer
struct  DCF77_Bits {
	unsigned long long M			:1	;
	unsigned long long O1			:1	;
	unsigned long long O2			:1	;
	unsigned long long O3			:1	;
	unsigned long long O4			:1	;
	unsigned long long O5			:1	;
	unsigned long long O6			:1	;
	unsigned long long O7			:1	;
	unsigned long long O8			:1	;
	unsigned long long O9			:1	;
	unsigned long long O10		:1	;
	unsigned long long O11		:1	;
	unsigned long long O12		:1	;
	unsigned long long O13		:1	;
	unsigned long long O14		:1	;
	unsigned long long R			:1	;
	unsigned long long A1			:1	;
	unsigned long long Z1			:1	;
	unsigned long long Z2			:1	;
	unsigned long long A2			:1	;
	unsigned long long S			:1	;
	unsigned long long Min1		:1	;	//Minute 1
	unsigned long long Min2		:1	;	//Minute 2
	unsigned long long Min4		:1	;	//Minute 4
	unsigned long long Min8		:1	;	//Minute 8
	unsigned long long Min10		:1	;	//Minute 10
	unsigned long long Min20		:1	;	//Minute 20
	unsigned long long Min40		:1	;	//Minute 40
	unsigned long long P1			:1	;	//Parity Minuten
	unsigned long long Hour1		:1	;	//Stunde 1
	unsigned long long Hour2		:1	;	//Stunde 2
	unsigned long long Hour4		:1	;	//Stunde 4
	unsigned long long Hour8		:1	;	//Stunde 8
	unsigned long long Hour10		:1	;	//Stunde 10
	unsigned long long Hour20		:1	;	//Stunde 20
	unsigned long long P2			:1	;	//Parity Stunden
	unsigned long long Day1		:1	;	//Tag im Monat 1
	unsigned long long Day2		:1	;	//Tag im Monat 2
	unsigned long long Day4		:1	;	//Tag im Monat 4
	unsigned long long Day8		:1	;	//Tag im Monat 8
	unsigned long long Day10		:1	;	//Tag im Monat 10
	unsigned long long Day20		:1	;	//Tag im Monat 20
	unsigned long long Weekday1	:1	;	//Wochentag 1 
	unsigned long long Weekday2	:1	;	//Wochentag 2
	unsigned long long Weekday4	:1	;	//Wochentag 4
	unsigned long long Month1		:1	;	//Monat 1
	unsigned long long Month2		:1	;	//Monat 2
	unsigned long long Month4		:1	;	//Monat 4
	unsigned long long Month8		:1	;	//Monat 8
	unsigned long long Month10	:1	;	//Monat 10
	unsigned long long Year1		:1	;	//Jahr 1 *****eine 5 fr das Jahr 2005*****
	unsigned long long Year2		:1	;	//Jahr 2
	unsigned long long Year4		:1	;	//Jahr 4
	unsigned long long Year8		:1	;	//Jahr 8
	unsigned long long Year10		:1	;	//Jahr 10
	unsigned long long Year20		:1	;	//Jahr 20
	unsigned long long Year40		:1	;	//Jahr 40
	unsigned long long Year80		:1	;	//Jahr 80
	unsigned long long P3			:1	;	//Parity von P2
	};
	
#endif //_CLOCK_H
